## openjk 0~20230306.ab77102+dfsg

=== debian/changelog ===
openjk (0~20230306.ab77102+dfsg-1) experimental; urgency=medium

  * New upstream snapshot
  * Update standards version to 4.6.2 (no changes needed)
  * Remove constraints unnecessary since buster (oldstable)
  * Drop unnecessary lsb-base dependency.
    In bookworm this is provided by the Essential sysvinit-utils package.
    In older releases, it was unnecessary when booting with systemd, and
    pulled in as a dependency by sysvinit-based init systems that used our
    LSB init script.

 -- Simon McVittie <smcv@debian.org>  Thu, 09 Mar 2023 10:52:42 +0000

openjk (0~20221013.c2095bb~dfsg-1) experimental; urgency=medium

  * New upstream snapshot
  * d/apparmor.d: Resync with ioquake3

 -- Simon McVittie <smcv@debian.org>  Tue, 01 Nov 2022 21:51:20 +0000

openjk (0~20220611.5ef6711~dfsg-1) experimental; urgency=medium

  * New upstream snapshot
  * Add missing need-data.sh.
    This displays the message about missing data files.
  * d/README/*-data: Fix some mistakenly repeated words
  * Standards-Version: 4.6.1 (no changes required)

 -- Simon McVittie <smcv@debian.org>  Mon, 20 Jun 2022 23:32:31 +0100

openjk (0~20220131.235fb9e~dfsg-1) experimental; urgency=medium

  * New upstream snapshot
  * Stop using dh-exec.
    We only used it for one file, which can be open-coded in d/rules without
    losing clarity.
  * Use recommended debhelper compat level 13

 -- Simon McVittie <smcv@debian.org>  Mon, 07 Feb 2022 11:21:16 +0000

openjk (0~20210731.43e9a3d~dfsg-1) experimental; urgency=medium

  * New upstream snapshot
  * Standards-Version: 4.6.0 (no changes required)
  * Remove Lintian overrides, no longer necessary

 -- Simon McVittie <smcv@debian.org>  Mon, 13 Dec 2021 13:24:48 +0000

openjk (0~20210115.d2ed03a~dfsg-1) experimental; urgency=medium

  * New upstream snapshot

 -- Simon McVittie <smcv@debian.org>  Tue, 26 Jan 2021 13:08:44 +0000

openjk (0~20201115.e64bbb5~dfsg-1) experimental; urgency=medium

  * New upstream snapshot
  * d/watch: Stop using uupdate
  * d/copyright: Exclude Visual C++ .rc files
  * Refresh patch series
  * Standards-Version: 4.5.1 (no changes required)
  * d/rules: Explicitly don't install unit tests.
    We run these at build-time.
  * d/rules: Don't symlink multiplayer modules into JediOutcast.
    OpenJK's support for Jedi Knight II: Jedi Outcast is single-player-only.
    We don't install the multiplayer modules; unnecessarily creating the
    symlinks causes warnings from debhelper.
  * Silence overzealous breakout-link lintian tags.
    OpenJK wants to see everything in a single non-FHS tree, and /usr/lib
    is the established place to build such trees by symlinking to files
    outside /usr/lib, in this case in /usr/share and /etc.
  * Remove unused lintian overrides for
    package-contains-documentation-outside-usr-share-doc

 -- Simon McVittie <smcv@debian.org>  Wed, 16 Dec 2020 11:30:31 +0000

openjk (0~20200914.0326204~dfsg-1) experimental; urgency=medium

  * New upstream snapshot
  * Link with -Wl,-z,defs to enforce that all modules are self-contained
  * d/rules: Don't force linking with -lm.
    All the built objects seem to be self-contained already, if only
    because the C++ linker always links to libm.

 -- Simon McVittie <smcv@debian.org>  Tue, 06 Oct 2020 21:07:43 +0100

openjk (0~20200610.24c5b27~dfsg-1) experimental; urgency=medium

  * New upstream snapshot
    - Drop patch, applied upstream
  * Update AppArmor profiles to use abstractions from 2.13.x.
    A suitable version is available in Debian 10 and Ubuntu 19.10.
  * d/copyright: Update

 -- Simon McVittie <smcv@debian.org>  Wed, 17 Jun 2020 12:55:52 +0100

openjk (0~20191129.eed6092~dfsg-1) experimental; urgency=medium

  * New upstream snapshot
  * d/p/Remove-FindSDL2-find-module-use-sdl2-config.cmake-instead.patch:
    Rely on libsdl2-dev (>= 2.0.4) providing a CMake "config-file package".
    This means we no longer need to copy/paste a FindSDL2 module, removing
    some redundant code; it also bypasses a regression in libsdl2-dev
    resulting from the introduction of multiarch support, which broke
    FindSDL2's assumptions, causing FTBFS. (Mitigates: #951087)
  * Standards-Version: 4.5.0 (no changes required)
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

 -- Simon McVittie <smcv@debian.org>  Fri, 14 Feb 2020 10:57:06 +0000

openjk (0~20191030.4881be7~dfsg-1) experimental; urgency=medium

  * New upstream snapshot
  * d/salsa-ci.yml: Request standard CI on salsa.debian.org
  * d/rules: Set LC_ALL=C.UTF-8 and TZ=UTC.
    This affects the build date derived from SOURCE_DATE_EPOCH,
    which should be the same for all builds to improve reproducibility.
  * Remove migration path from openjk-dbg, which was removed in 2016
  * Standards-Version: 4.4.1 (no changes required)

 -- Simon McVittie <smcv@debian.org>  Sat, 02 Nov 2019 22:39:20 +0000

=== debian/control ===
Source: openjk
Section: contrib/games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Simon McVittie <smcv@debian.org>
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 dh-apparmor [linux-any],
 icnsutils,
 imagemagick,
 libboost-test-dev,
 libjpeg-dev,
 libpng-dev,
 libsdl2-dev,
 zip,
Rules-Requires-Root: no
Standards-Version: 4.6.2
Vcs-Git: https://salsa.debian.org/games-team/openjk.git
Vcs-Browser: https://salsa.debian.org/games-team/openjk
Homepage: https://github.com/JACoders/OpenJK

Package: openjk-academy
Architecture: any
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 jedi-academy-data (>= 1.01+41) | game-data-packager,
 jedi-academy-data (>= 1.01+41) | x11-utils | zenity | kdialog,
 openjk-common (= ${binary:Version}),
Description: Jedi Academy single-player and multiplayer game engine
 Star Wars Jedi Knight: Jedi Academy is a first- and third-person
 action game set in the Star Wars universe, developed by Raven Software
 and first released in 2003.
 .
 This package contains the openjk_sp and openjk, the OpenJK single-player
 and multiplayer game engines for Jedi Academy, based on the 2013 GPL
 source release and modified to work on modern systems.
 It requires non-distributable game data files in the
 jedi-academy-data package, prepared using the game-data-packager tool.
 .
 Jedi Academy is a sequel to Star Wars Jedi Knight II: Jedi Outcast, for
 which an experimental engine is available in the openjk-outcast package.

Package: openjk-academy-server
Architecture: any
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 adduser,
 jedi-academy-data (>= 1.01+41) | game-data-packager,
 openjk-common (= ${binary:Version}),
Description: Jedi Academy multiplayer game server
 Star Wars Jedi Knight: Jedi Academy is a first- and third-person
 action game set in the Star Wars universe, developed by Raven Software
 and first released in 2003.
 .
 This package contains openjkded, the OpenJK multiplayer dedicated server
 for Jedi Academy, based on the 2013 GPL source release and modified to work
 on modern systems. It also contains init scripts to run the server
 automatically; on systemd systems, multiple instances are supported.
 .
 OpenJK requires non-distributable game data files in the jedi-academy-data
 package, prepared using the game-data-packager tool.

Package: openjk-outcast
Architecture: any
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 jedi-outcast-data (>= 1.04+41) | game-data-packager,
 openjk-common (= ${binary:Version}),
Description: experimental Jedi Outcast single-player game engine
 Star Wars Jedi Knight II: Jedi Outcast is a first- and third-person
 action game set in the Star Wars universe, developed by Raven Software
 and first released in 2002.
 .
 This package contains openjo_sp, the OpenJK single-player game engine for
 Jedi Outcast, based on the 2013 GPL source release and modified to work
 on modern systems. It requires non-distributable game data files in the
 jedi-outcast-data package, prepared using the game-data-packager tool.
 .
 This version of the OpenJK engine is a mixture of code originating from
 Jedi Outcast and its sequel Jedi Academy; it is not currently considered to
 be stable, and does not have a multiplayer component. See the openjk-academy
 package for the sequel, Star Wars Jedi Knight: Jedi Academy, which is more
 stable and does support multiplayer.

Package: openjk-common
Architecture: any
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 game-data-packager,
Description: common files for all OpenJK games
 This package contains files shared by all versions of the OpenJK engine.
 It is used by the openjk-academy, openjk-outcast and openjk-academy-server
 packages.
 .
 It is unnecessary to install this package unless you are installing one
 of the packages that depends on it.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export LC_ALL=C.UTF-8
export TZ=UTC

# Flags valid in both CFLAGS and CXXFLAGS
compiler_flags := \
	-Wall \
	-Wno-unused-parameter \
	-Wno-missing-field-initializers \
	-fno-strict-aliasing \
	-Wno-strict-aliasing \
	-Wno-unused-but-set-variable \
	$(NULL)
DEB_CFLAGS_MAINT_APPEND := \
	$(compiler_flags) \
	$(NULL)
DEB_CXXFLAGS_MAINT_APPEND := \
	$(compiler_flags) \
	$(NULL)
# OpenJK assumes that absence of -D_DEBUG implies -DNDEBUG
DEB_CPPFLAGS_MAINT_APPEND := \
	-DNDEBUG \
	$(NULL)
DEB_LDFLAGS_MAINT_APPEND := \
	-Wl,-z,defs \
	$(NULL)

include /usr/share/dpkg/default.mk

# OpenJK upstream consider their support for Jedi Knight II: Jedi Outcast
# to be very much experimental, so don't build it for unstable or Ubuntu
# by default. Override with DEB_BUILD_OPTIONS=[no]outcast
ifneq (,$(filter nooutcast,$(DEB_BUILD_OPTIONS)))
$(info Disabling JK2 because DEB_BUILD_OPTIONS=nooutcast)
with_jk2 = OFF
else
ifneq (,$(filter outcast,$(DEB_BUILD_OPTIONS)))
$(info Enabling JK2 because DEB_BUILD_OPTIONS=outcast)
with_jk2 = ON
else
ifeq (,$(filter-out experimental UNRELEASED,$(DEB_DISTRIBUTION)))
$(info Enabling JK2 because this is an experimental or UNRELEASED build)
with_jk2 = ON
else
$(info Disabling JK2 by default)
with_jk2 = OFF
endif
endif
endif

dh_options =
ifneq ($(with_jk2),ON)
dh_options += -Nopenjk-outcast
endif

# for convenience, use a builddir that is excluded by upstream's .gitignore
%:
	dh $@ --builddir=obj $(dh_options)

override_dh_auto_configure:
	dh_auto_configure -- \
		-DBuildJK2SPEngine=$(with_jk2) \
		-DBuildJK2SPRdVanilla=$(with_jk2) \
		-DBuildJK2SPGame=$(with_jk2) \
		-DBuildTests=ON \
		-DCMAKE_BUILD_TYPE=None \
		-DCMAKE_INSTALL_PREFIX=/usr/lib/openjk \
		-DCMAKE_VERBOSE_MAKEFILE=TRUE \
		$(NULL)

override_dh_auto_build: debian/icons
	dh_auto_build

override_dh_auto_install: DESTDIR = debian/tmp
override_dh_auto_install: debian/icons
	dh_auto_install
	install -D -m644 README.md $(DESTDIR)/usr/share/doc/openjk-common/README
	cd $(DESTDIR)/usr/lib/openjk/JediAcademy && ln -s openjk_sp.* openjk_sp
	cd $(DESTDIR)/usr/lib/openjk/JediAcademy && ln -s openjk.* openjk
	cd $(DESTDIR)/usr/lib/openjk/JediAcademy && ln -s openjkded.* openjkded
	install -d $(DESTDIR)/usr/lib/openjk/JediAcademy/base
	rm -fv $(DESTDIR)/usr/lib/openjk/JediAcademy/base/*.so
	rm -f $(DESTDIR)/usr/lib/openjk/UnitTests
	cd $(DESTDIR)/usr/lib/openjk/JediAcademy/base && ln -nfsv ../OpenJK/*.so .
	sed \
		-e 's!@IOQ3BINARY@!openjk_sp!' \
		-e 's!@IOQ3SELF@!openjk_sp!' \
		-e 's!@LIBDIR@!openjk/JediAcademy!' \
		-e 's!@DATA@!jedi-academy-data!' \
		-e 's!@IOQ3GAME@!Jedi Academy!' \
		-e 's!@IOQ3ROLE@!single-player!' \
		< debian/scripts/jedi.in > debian/scripts/openjk_sp
	sed \
		-e 's!@IOQ3BINARY@!openjk!' \
		-e 's!@IOQ3SELF@!openjk!' \
		-e 's!@LIBDIR@!openjk/JediAcademy!' \
		-e 's!@DATA@!jedi-academy-data!' \
		-e 's!@IOQ3GAME@!Jedi Academy!' \
		-e 's!@IOQ3ROLE@!multiplayer!' \
		< debian/scripts/jedi.in > debian/scripts/openjk
	sed \
		-e 's!@IOQ3BINARY@!openjkded!' \
		-e 's!@IOQ3SELF@!openjkded!' \
		-e 's!@LIBDIR@!openjk/JediAcademy!' \
		-e 's!@DATA@!jedi-academy-data!' \
		-e 's!@IOQ3GAME@!Jedi Academy!' \
		-e 's!@IOQ3ROLE@!server!' \
		< debian/scripts/jedi.in > debian/scripts/openjkded
ifeq ($(with_jk2),ON)
	cd $(DESTDIR)/usr/lib/openjk/JediOutcast && ln -s openjo_sp.* openjo_sp
	install -d $(DESTDIR)/usr/lib/openjk/JediOutcast/OpenJK
	cd $(DESTDIR)/usr/lib/openjk/JediOutcast/OpenJK && ln -s ../../JediAcademy/OpenJK/cgame*.so .
	cd $(DESTDIR)/usr/lib/openjk/JediOutcast/OpenJK && ln -s ../../JediAcademy/OpenJK/ui*.so .
	install -d $(DESTDIR)/usr/lib/openjk/JediOutcast/base
	rm -fv $(DESTDIR)/usr/lib/openjk/JediOutcast/base/*.so
	cd $(DESTDIR)/usr/lib/openjk/JediOutcast/base && ln -s ../OpenJK/jospgame*.so .
	cd $(DESTDIR)/usr/lib/openjk/JediOutcast/base && ln -s ../../JediAcademy/OpenJK/cgame*.so .
	cd $(DESTDIR)/usr/lib/openjk/JediOutcast/base && ln -s ../../JediAcademy/OpenJK/ui*.so .
	sed \
		-e 's!@IOQ3BINARY@!openjo_sp!' \
		-e 's!@IOQ3SELF@!openjo_sp!' \
		-e 's!@LIBDIR@!openjk/JediOutcast!' \
		-e 's!@DATA@!jedi-outcast-data!' \
		-e 's!@IOQ3GAME@!Jedi Knight II: Jedi Outcast!' \
		-e 's!@IOQ3ROLE@!single-player!' \
		< debian/scripts/jedi.in > debian/scripts/openjo_sp
endif
	chmod 0755 debian/scripts/openj*

ifeq ($(DEB_HOST_ARCH_OS),linux)
override_dh_install:
	dh_install
	dh_apparmor -popenjk-common --profile-name=usr.games.openjk
	dh_apparmor -popenjk-academy-server --profile-name=usr.games.openjkded
endif

override_dh_installchangelogs:
	dh_installchangelogs CHANGELOG.md

debian/icons: debian/rules
	install -d debian/icons/512 debian/icons/128 \
		debian/icons/64 debian/icons/32 debian/icons/16
	install -m644 shared/icons/OpenJK_Icon_128.png debian/icons/128/openjk.png
	install -m644 shared/icons/OpenJK_Icon_64.png debian/icons/64/openjk.png
	install -m644 shared/icons/OpenJK_Icon_32.png debian/icons/32/openjk.png
	install -m644 shared/icons/OpenJK_Icon_16.png debian/icons/16/openjk.png
	convert -resize 512x512 shared/icons/OpenJK_Icon_1024.png \
		debian/icons/512/openjk.png

# no libraries here, only plugins
override_dh_makeshlibs:
	:

override_dh_clean:
	rm -fr debian/icons
	dh_clean

## openjk 0~20240620.c11082b+dfsg

=== CMakeLists.txt ===
#============================================================================
# Copyright (C) 2013 - 2018, OpenJK contributors
#
# This file is part of the OpenJK source code.
#
# OpenJK is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License version 2 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.
#============================================================================

cmake_minimum_required(VERSION 3.1)
set(CMAKE_OSX_DEPLOYMENT_TARGET "10.9" CACHE STRING "Minimum OS X deployment version")

set(InOpenJK ON)

set(ProjectName "OpenJK" CACHE STRING "Project Name")
project(${ProjectName})

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})

#=============================================================================
#
# Customizable options
#
#=============================================================================
option(BuildPortableVersion "Build portable version (does not read or write files from your user/home directory" OFF)

option(BuildMPEngine "Whether to create projects for the MP client (openjk.exe)" ON)
option(BuildMPRdVanilla "Whether to create projects for the MP default renderer (rd-vanilla_x86.dll)" ON)
option(BuildMPDed "Whether to create projects for the MP dedicated server (openjkded.exe)" ON)
option(BuildMPGame "Whether to create projects for the MP server-side gamecode (jampgamex86.dll)" ON)
option(BuildMPCGame "Whether to create projects for the MP clientside gamecode (cgamex86.dll)" ON)
option(BuildMPUI "Whether to create projects for the MP UI code (uix86.dll)" ON)
option(BuildMPRend2 "Whether to create projects for the EXPERIMENTAL MP rend2 renderer (rd-rend2_x86.dll)" ON)

option(BuildSPEngine "Whether to create projects for the SP engine (openjk_sp.exe)" ON)
option(BuildSPGame "Whether to create projects for the SP gamecode (jagamex86.dll)" ON)
option(BuildSPRdVanilla "Whether to create projects for the SP default renderer (rdsp-vanilla_x86.dll)" ON)

option(BuildJK2SPEngine "Whether to create projects for the jk2 SP engine (openjo_sp.exe)" OFF)
option(BuildJK2SPGame "Whether to create projects for the jk2 sp gamecode mod (jk2gamex86.dll)" OFF)
option(BuildJK2SPRdVanilla "Whether to create projects for the jk2 sp renderer (rdjosp-vanilla_x86.dll)" OFF)

option(BuildTests "Whether to build automatic unit tests (requires Boost)" OFF)

include(CMakeDependentOption)
cmake_dependent_option(BuildSymbolServer "Build WIP Windows Symbol Server (experimental and unused)" OFF "NOT WIN32 OR NOT MSVC" OFF)

# Configure the use of bundled libraries.  By default, we assume the user is on
# a platform that does not require any bundling.
#
# Note that we always use the bundled copy of minizip, since it is modified to
# use Z_Malloc.

set(UseInternalOpenALDefault OFF)
set(UseInternalZlibDefault   OFF)
set(UseInternalPNGDefault    OFF)
set(UseInternalJPEGDefault   OFF)
set(UseInternalSDL2Default   OFF)

if(UseInternalLibs OR WIN32)
  set(UseInternalOpenALDefault ON)
  set(UseInternalZlibDefault   ON)
  set(UseInternalPNGDefault    ON)
  set(UseInternalJPEGDefault   ON)
  set(UseInternalSDL2Default   ON)
endif()

if(APPLE)
  set(UseInternalJPEGDefault ON)
endif()

option(UseInternalOpenAL "If set, use bundled OpenAL."  ${UseInternalOpenALDefault})
option(UseInternalZlib   "If set, use bundled zlib."    ${UseInternalZlibDefault})
option(UseInternalPNG    "If set, use bundled libpng."  ${UseInternalPNGDefault})
option(UseInternalJPEG   "If set, use bundled libjpeg." ${UseInternalJPEGDefault})
option(UseInternalSDL2   "If set, use bundled SDL2."    ${UseInternalSDL2Default})

# This option won't appear on non-Apple platforms.
if(APPLE)
  option(MakeApplicationBundles "Whether to build .app application bundles for engines built" ON)
endif()

#=============================================================================
#
# Custom CMake Modules needed
#
#=============================================================================
list(INSERT CMAKE_MODULE_PATH 0 "${CMAKE_SOURCE_DIR}/cmake/Modules")

if(CMAKE_EXPORT_COMPILE_COMMANDS)
	add_custom_target(
		copy-compile-commands ALL
		${CMAKE_COMMAND} -E copy_if_different
		${CMAKE_BINARY_DIR}/compile_commands.json
		${CMAKE_CURRENT_LIST_DIR})
endif()

#=============================================================================
#
# Architecture/OS defines
#
#=============================================================================
# ${Architecture} must match ARCH_STRING in q_platform.h,
# and is used in DLL names (jagamex86.dll, jagamex86.dylib, jagamei386.so).
if(WIN32)
	set(X86 ON)
	if(CMAKE_SIZEOF_VOID_P MATCHES "8")
		set(Architecture "x86_64")
		set(WIN64 TRUE)
	else()
		set(Architecture "x86")
		set(WIN64 FALSE)
	endif()
else()
	set(X86 OFF)
	if(CMAKE_SYSTEM_PROCESSOR MATCHES "^(arm64|aarch64)$")
		set(Architecture "arm64")
		add_definitions(-DPNG_ARM_NEON_OPT=0)
	elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "^arm")
		set(Architecture "arm")
	elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "^i.86$")
		set(X86 ON)
		if(APPLE)
			set(Architecture "x86")
		else()
			# e.g. Linux
			set(Architecture "i386")
		endif()
	elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "^x86.64$")
		set(X86 ON)
		set(Architecture "x86_64")
	elseif(CMAKE_SYSTEM_PROCESSOR STREQUAL "powerpc")
		set(Architecture "ppc")
	elseif(CMAKE_SYSTEM_PROCESSOR STREQUAL "powerpc64")
		set(Architecture "ppc64")
	else()
		set(Architecture "${CMAKE_SYSTEM_PROCESSOR}")
	endif()
endif()

message(STATUS "Architecture is ${Architecture}")

if(WIN32 AND CMAKE_VERSION VERSION_LESS "3.4")
	message(WARNING "Building on Windows platform with CMake version less than 3.4 is deprecated. Manifest file will fail to be included.")
endif()

#=============================================================================
#
# Binary names
#
#=============================================================================
set(SPEngine "openjk_sp.${Architecture}")
set(SPGame "jagame${Architecture}")
set(SPRDVanillaRenderer "rdsp-vanilla_${Architecture}")
set(MPEngine "openjk.${Architecture}")
set(MPVanillaRenderer "rd-vanilla_${Architecture}")
set(MPDed "openjkded.${Architecture}")
set(MPGame "jampgame${Architecture}")
set(MPCGame "cgame${Architecture}")
set(MPUI "ui${Architecture}")
set(MPRend2 "rd-rend2_${Architecture}")
set(JK2SPEngine "openjo_sp.${Architecture}")
set(JK2SPGame "jospgame${Architecture}")
set(JK2SPVanillaRenderer "rdjosp-vanilla_${Architecture}")
set(AssetsPk3 "openjk-${Architecture}.pk3")
# Library names
set(MPBotLib "botlib")
set(SharedLib "shared")

#=============================================================================
#
# Paths
#
#=============================================================================
set(SPDir "${CMAKE_SOURCE_DIR}/code")
set(MPDir "${CMAKE_SOURCE_DIR}/codemp")
set(JK2SPDir "${CMAKE_SOURCE_DIR}/codeJK2")
set(SharedDir ${CMAKE_SOURCE_DIR}/shared)
set(OpenJKLibDir "${CMAKE_SOURCE_DIR}/lib")
set(GSLIncludeDirectory "${OpenJKLibDir}/gsl-lite/include")

include(InstallConfig)

#=============================================================================
#
# Compiler definitions/flags
#
#=============================================================================

# Operating system settings
if(WIN64)
	set(SharedDefines ${SharedDefines} "WIN64")
endif()

if (APPLE)
	set(SharedDefines ${SharedDefines} "MACOS_X")
endif()

if (NOT WIN32 AND NOT APPLE)
	set(SharedDefines ${SharedDefines} "ARCH_STRING=\"${Architecture}\"")
endif()

if(CMAKE_SYSTEM_NAME MATCHES "BSD")
  add_definitions(-DIOAPI_NO_64)
endif()

# Compiler settings
if(MSVC)
	set(SharedDefines ${SharedDefines} "NOMINMAX")
	set(SharedDefines ${SharedDefines} "_CRT_SECURE_NO_WARNINGS")
	set(SharedDefines ${SharedDefines} "_SCL_SECURE_NO_WARNINGS")
	set(SharedDefines ${SharedDefines} "_CRT_NONSTDC_NO_DEPRECATE")

	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /arch:SSE2")
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /MP")

	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /arch:SSE2")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP")

	# We don't try to control symbol visibility under MSVC.
	set(OPENJK_VISIBILITY_FLAGS "")
elseif (("${CMAKE_C_COMPILER_ID}" STREQUAL "GNU") OR ("${CMAKE_C_COMPILER_ID}" MATCHES "Clang"))
	# I hope this doesn't come back to bite me in the butt later on.
	# Realistically though, can the C and CXX compilers be different?

	# Visibility can't be set project-wide -- it needs to be specified on a
	# per-target basis.  This is primarily due to the bundled copy of ZLib.
	# ZLib explicitly declares symbols hidden, rather than defaulting to hidden.
	#
	# Note that -fvisibility=hidden is stronger than -fvisibility-inlines-hidden.
	set(OPENJK_VISIBILITY_FLAGS "-fvisibility=hidden")

	# removes the -rdynamic flag at linking (which causes crashes for some reason)
	set(CMAKE_SHARED_LIBRARY_LINK_C_FLAGS "")
	set(CMAKE_SHARED_LIBRARY_LINK_CXX_FLAGS "")

	# additional flags for debug configuration
	set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -ggdb")
	set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -ggdb")

	if (X86)
		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -msse2")
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -msse2")
	endif()

	set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} -O3")
	set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -O3")

	# enable somewhat modern C++
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")

	if("${CMAKE_C_COMPILER_ID}" STREQUAL "GNU")
		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall")
		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-comment")
		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsigned-char")
		if (X86)
			# "x86 vm will crash without -mstackrealign since MMX
			# instructions will be used no matter what and they
			# corrupt the frame pointer in VM calls"
			# -ioquake3 Makefile
			set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -mstackrealign")
			set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -mfpmath=sse")
		endif()

		if(WIN32)
			# Link libgcc and libstdc++ statically
			set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -static-libgcc")
			set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -static-libgcc")
			set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -static-libstdc++")
		endif()
	elseif("${CMAKE_C_COMPILER_ID}" MATCHES "Clang")
		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall")
		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-comment")
		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsigned-char")
	endif()

	if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-invalid-offsetof")
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-write-strings")
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-comment")
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsigned-char")
		if (X86)
			set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mstackrealign")
			set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mfpmath=sse")
		endif()
	elseif("${CMAKE_CXX_COMPILER_ID}" MATCHES "Clang")
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-write-strings")
		#set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-deprecated-writable-strings")
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-comment")
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-invalid-offsetof")
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsigned-char")
	endif()
else()
	message(ERROR "Unsupported compiler")
endif()

set(SharedDefines ${SharedDefines} "$<$<CONFIG:Debug>:_DEBUG>")
set(SharedDefines ${SharedDefines} "$<$<NOT:$<CONFIG:Debug>>:FINAL_BUILD>")

if(BuildPortableVersion)
	set(BUILD_PORTABLE ON)
endif()

#=============================================================================
#
# Generate version file
#

=== code/CMakeLists.txt ===
#============================================================================
# Copyright (C) 2013 - 2018, OpenJK contributors
#
# This file is part of the OpenJK source code.
#
# OpenJK is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License version 2 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.
#============================================================================

# Make sure the user is not executing this script directly
if(NOT InOpenJK)
	message(FATAL_ERROR "Use the top-level cmake script!")
endif(NOT InOpenJK)

#    Add Game Project
if(BuildSPGame)
	add_subdirectory("${SPDir}/game")
endif(BuildSPGame)

#    Add Modular Renderer project
add_subdirectory("${SPDir}/rd-vanilla")

#    Add Engine Project
if(BuildSPEngine OR BuildJK2SPEngine)
	# Libraries
	if(WIN32)
		set(SPEngineLibraries "winmm")
	endif(WIN32)
	# Defines
	set(SPEngineDefines ${SharedDefines} "_JK2EXE") # it's called JK2EXE but it really just means Singleplayer Exe

	set(SPEngineIncludeDirectories
		${SPEngineIncludeDirectories}
		${SharedDir}
		${CMAKE_BINARY_DIR}/shared
		${SPDir}
		"${GSLIncludeDirectory}")

	#    Dependencies
	# OpenAL (is optionally included for Windows)
	if(MSVC AND NOT WIN64)
		if(UseInternalOpenAL)
			# There's a libs/OpenAL32.lib
			# (mrw) TODO Is this actually required on windows? It is loaded at runtime, should not be linked?
			find_library(OpenALLibrary NAMES OpenAL32 PATHS "${OpenJKLibDir}")
			if(NOT OpenALLibrary)
				message(FATAL_ERROR "UseInternalOpenAL enabled, but lib/OpenAL32.lib not found!")
			endif(NOT OpenALLibrary)
			set(SPEngineLibraries ${SPEngineLibraries} ${OpenALLibrary})
		else(UseInternalOpenAL)
			find_package(OpenAL REQUIRED)
			set(SPEngineIncludeDirectories ${SPEngineIncludeDirectories} ${OPENAL_INCLUDE_DIR})
			set(SPEngineLibraries ${SPEngineLibraries} ${OPENAL_LIBRARY})
		endif(UseInternalOpenAL)

		set(SPEngineEAXFiles
			"${SPDir}/client/eax/eax.h"
			"${SPDir}/client/eax/EaxMan.h"
			)
		source_group("eax" FILES ${SPEngineEAXFiles})
		set(SPEngineFiles ${SPEngineFiles} ${SPEngineEAXFiles})
	endif()

	if(UseInternalSDL2)
		if(CMAKE_SIZEOF_VOID_P EQUAL 4)
			set(SPEngineLibraries
				${SPEngineLibraries}
				${OpenJKLibDir}/SDL2/lib/x86/SDL2main.lib
				${OpenJKLibDir}/SDL2/lib/x86/SDL2.lib
				)
		else()
			set(SPEngineLibraries
				${SPEngineLibraries}
				${OpenJKLibDir}/SDL2/lib/x64/SDL2main.lib
				${OpenJKLibDir}/SDL2/lib/x64/SDL2.lib
				)
		endif()

		set(SPEngineIncludeDirectories
			${SPEngineIncludeDirectories}
			${OpenJKLibDir}/SDL2/include
			)
	else()
		find_package(SDL2 REQUIRED CONFIG)
		if (TARGET SDL2::SDL2)
			set(SDL2_INCLUDE_DIRS "")
			set(SDL2_LIBRARIES SDL2::SDL2)
		endif()
		string(STRIP ${SDL2_LIBRARIES} SDL2_LIBRARIES)
		set(SPEngineIncludeDirectories ${SPEngineIncludeDirectories} ${SDL2_INCLUDE_DIRS})
		set(SPEngineLibraries ${SPEngineLibraries} ${SDL2_LIBRARIES})
	endif()

	#    Source Files

	# Client files
	set(SPEngineClientFiles
		"${SPDir}/client/keys.h"
		"${SPDir}/client/keycodes.h"

		"${SPDir}/client/cl_cgame.cpp"
		"${SPDir}/client/cl_cin.cpp"
		"${SPDir}/client/cl_console.cpp"
		"${SPDir}/client/cl_input.cpp"
		"${SPDir}/client/cl_keys.cpp"
		"${SPDir}/client/cl_main.cpp"
		"${SPDir}/client/cl_mp3.cpp"
		"${SPDir}/client/cl_parse.cpp"
		"${SPDir}/client/cl_scrn.cpp"
		"${SPDir}/client/cl_ui.cpp"
		"${SPDir}/client/cl_mp3.h"
		"${SPDir}/client/client.h"
		"${SPDir}/client/client_ui.h"

		"${SPDir}/client/snd_ambient.cpp"
		"${SPDir}/client/snd_dma.cpp"
		"${SPDir}/client/snd_mem.cpp"
		"${SPDir}/client/snd_mix.cpp"
		"${SPDir}/client/snd_music.cpp"
		"${SPDir}/client/snd_ambient.h"
		"${SPDir}/client/snd_local.h"
		"${SPDir}/client/snd_music.h"
		"${SPDir}/client/snd_public.h"

		"${SPDir}/client/vmachine.cpp"
		"${SPDir}/client/vmachine.h"
		)
	source_group("client" FILES ${SPEngineClientFiles})
	set(SPEngineFiles ${SPEngineFiles} ${SPEngineClientFiles})


	# qcommon files
	set(SPEngineCommonFiles
		"${SPDir}/qcommon/cm_load.cpp"
		"${SPDir}/qcommon/cm_patch.cpp"
		"${SPDir}/qcommon/cm_polylib.cpp"
		"${SPDir}/qcommon/cm_test.cpp"
		"${SPDir}/qcommon/cm_trace.cpp"
		"${SPDir}/qcommon/cm_local.h"
		"${SPDir}/qcommon/cm_patch.h"
		"${SPDir}/qcommon/cm_polylib.h"
		"${SPDir}/qcommon/cm_public.h"

		"${SPDir}/qcommon/cmd.cpp"
		"${SPDir}/qcommon/common.cpp"
		"${SPDir}/qcommon/cvar.cpp"

		"${SPDir}/qcommon/files.cpp"

		"${SPDir}/qcommon/md4.cpp"
		"${SPDir}/qcommon/msg.cpp"
		"${SPDir}/qcommon/net_chan.cpp"

		"${SPDir}/qcommon/q_shared.cpp"
		"${SPDir}/qcommon/q_shared.h"

		"${SPDir}/qcommon/sstring.h"
		"${SPDir}/qcommon/stringed_ingame.cpp"
		"${SPDir}/qcommon/stringed_interface.cpp"
		"${SPDir}/qcommon/stringed_ingame.h"
		"${SPDir}/qcommon/stringed_interface.h"

		"${SPDir}/qcommon/strip.cpp"
		"${SPDir}/qcommon/persistence.cpp"
		"${SPDir}/qcommon/tags.h"
		"${SPDir}/qcommon/z_memman_pc.cpp"
		"${SPDir}/qcommon/qfiles.h"
		"${SPDir}/qcommon/qcommon.h"
		"${SPDir}/qcommon/stv_version.h"
		"${SPDir}/qcommon/timing.h"
		"${SPDir}/qcommon/MiniHeap.h"

		"${SPDir}/qcommon/ojk_i_saved_game.h"
		"${SPDir}/qcommon/ojk_saved_game.h"
		"${SPDir}/qcommon/ojk_saved_game.cpp"
		"${SPDir}/qcommon/ojk_saved_game_helper.h"
		"${SPDir}/qcommon/ojk_saved_game_helper_fwd.h"
		"${SPDir}/qcommon/ojk_scope_guard.h"

		${SharedCommonFiles}
		)
	source_group("common" FILES ${SPEngineCommonFiles})
	set(SPEngineFiles ${SPEngineFiles} ${SPEngineCommonFiles})

	set(SPEngineCommonSafeFiles
		"${SharedDir}/qcommon/safe/files.cpp"
		"${SharedDir}/qcommon/safe/files.h"
		${SharedCommonSafeFiles}
		"${SPDir}/qcommon/safe/memory.h"
		)
	source_group("common/safe" FILES ${SPEngineCommonSafeFiles})
	set(SPEngineFiles ${SPEngineFiles} ${SPEngineCommonSafeFiles})


	# Server files
	set(SPEngineServerFiles
		"${SPDir}/server/exe_headers.cpp"
		"${SPDir}/server/sv_ccmds.cpp"
		"${SPDir}/server/sv_client.cpp"
		"${SPDir}/server/sv_game.cpp"
		"${SPDir}/server/sv_init.cpp"
		"${SPDir}/server/sv_main.cpp"
		"${SPDir}/server/sv_savegame.cpp"
		"${SPDir}/server/sv_snapshot.cpp"
		"${SPDir}/server/sv_world.cpp"
		"${SPDir}/server/exe_headers.h"
		"${SPDir}/server/server.h"
		)
	source_group("server" FILES ${SPEngineServerFiles})
	set(SPEngineFiles ${SPEngineFiles} ${SPEngineServerFiles})


	# Game files
	set(SPEngineGameFiles
		"${SPDir}/game/genericparser2.cpp"
		"${SPDir}/game/channels.h"
		"${SPDir}/game/anims.h"
		"${SPDir}/game/b_public.h"
		"${SPDir}/game/bg_public.h"
		"${SPDir}/game/bset.h"
		"${SPDir}/game/bstate.h"
		"${SPDir}/game/common_headers.h"
		"${SPDir}/game/g_functions.h"
		"${SPDir}/game/g_items.h"
		"${SPDir}/game/g_local.h"
		"${SPDir}/game/g_nav.h"
		"${SPDir}/game/g_public.h"
		"${SPDir}/game/g_shared.h"
		"${SPDir}/game/genericparser2.h"
		"${SPDir}/game/statindex.h"
		"${SPDir}/game/teams.h"
		"${SPDir}/game/weapons.h"
		"${SPDir}/game/surfaceflags.h"
		"${SPDir}/game/ghoul2_shared.h"
		)
	source_group("game" FILES ${SPEngineGameFiles})
	set(SPEngineFiles ${SPEngineFiles} ${SPEngineGameFiles})


	# MP3 files
	set(SPEngineMP3Files
		"${SPDir}/mp3code/cdct.c"
		"${SPDir}/mp3code/csbt.c"
		"${SPDir}/mp3code/csbtb.c"
		"${SPDir}/mp3code/csbtl3.c"
		"${SPDir}/mp3code/cup.c"
		"${SPDir}/mp3code/cupini.c"
		"${SPDir}/mp3code/cupl1.c"
		"${SPDir}/mp3code/cupl3.c"
		"${SPDir}/mp3code/cwin.c"
		"${SPDir}/mp3code/cwinb.c"
		"${SPDir}/mp3code/cwinm.c"
		"${SPDir}/mp3code/hwin.c"
		"${SPDir}/mp3code/l3dq.c"
		"${SPDir}/mp3code/l3init.c"
		"${SPDir}/mp3code/mdct.c"
		"${SPDir}/mp3code/mhead.c"
		"${SPDir}/mp3code/msis.c"
		"${SPDir}/mp3code/towave.c"
		"${SPDir}/mp3code/uph.c"
		"${SPDir}/mp3code/upsf.c"
		"${SPDir}/mp3code/wavep.c"
		"${SPDir}/mp3code/config.h"
		"${SPDir}/mp3code/htable.h"
		"${SPDir}/mp3code/jdw.h"
		"${SPDir}/mp3code/l3.h"
		"${SPDir}/mp3code/mhead.h"
		"${SPDir}/mp3code/mp3struct.h"
		"${SPDir}/mp3code/port.h"
		"${SPDir}/mp3code/small_header.h"
		"${SPDir}/mp3code/tableawd.h"
		)
	source_group("mp3" FILES ${SPEngineMP3Files})
	set(SPEngineFiles ${SPEngineFiles} ${SPEngineMP3Files})

	set(SPEngineRendererFiles
		"${SPDir}/rd-common/mdx_format.h"
		"${SPDir}/rd-common/tr_public.h"
		"${SPDir}/rd-common/tr_types.h"
		)
	source_group("renderer" FILES ${SPEngineRendererFiles})
	set(SPEngineFiles ${SPEngineFiles} ${SPEngineRendererFiles})

	# UI files
	set(SPEngineUIFiles
		"${SPDir}/ui/ui_atoms.cpp"
		"${SPDir}/ui/ui_connect.cpp"
		"${SPDir}/ui/ui_main.cpp"
		"${SPDir}/ui/ui_saber.cpp"
		"${SPDir}/ui/ui_shared.cpp"
		"${SPDir}/ui/ui_syscalls.cpp"
		"${SPDir}/ui/gameinfo.h"
		"${SPDir}/ui/menudef.h"
		"${SPDir}/ui/ui_local.h"
		"${SPDir}/ui/ui_public.h"
		"${SPDir}/ui/ui_shared.h"
		)
	source_group("ui" FILES ${SPEngineUIFiles})
	set(SPEngineFiles ${SPEngineFiles} ${SPEngineUIFiles})


	# Ghoul2 files
	set(SPEngineGhoul2Files
		"${SPDir}/ghoul2/G2.h"
		"${SPDir}/ghoul2/ghoul2_gore.h"
		)
	source_group("ghoul2" FILES ${SPEngineGhoul2Files})
	set(SPEngineFiles ${SPEngineFiles} ${SPEngineGhoul2Files})


	# Server files
	set(SPEngineCGameFiles
		"${SPDir}/cgame/cg_public.h"
		"${SPDir}/cgame/animtable.h"
		)
	source_group("cgame" FILES ${SPEngineCGameFiles})
	set(SPEngineFiles ${SPEngineFiles} ${SPEngineCGameFiles})

	if(WIN32)
		set(SPEngineWin32Files
			"${SPDir}/win32/resource.h"
			"${SPDir}/win32/winquake.rc"
			"${SharedDir}/sys/win_manifest.manifest"
			)
		source_group("win32" FILES ${SPEngineWin32Files})
		set(SPEngineFiles ${SPEngineFiles} ${SPEngineWin32Files})
	endif()

	set(SPEngineSysFiles
		"${SharedDir}/sys/sys_main.cpp"
		"${SharedDir}/sys/sys_event.cpp"
		"${SharedDir}/sys/sys_local.h"
		"${SharedDir}/sys/sys_public.h"
		"${SharedDir}/sys/sys_loadlib.h"
		"${SharedDir}/sys/con_local.h"
		"${SharedDir}/sys/con_log.cpp"
		"${SharedDir}/sdl/sdl_qgl.h"
		"${SharedDir}/sdl/sdl_sound.cpp"
		"${SharedDir}/sdl/sdl_input.cpp"
		"${SharedDir}/sdl/sdl_window.cpp"
		"${SharedDir}/sdl/sdl_icon.h"
		)

	if(WIN32)
		set(SPEngineSysFiles
			${SPEngineSysFiles}
			"${SharedDir}/sys/sys_win32.cpp"
			"${SharedDir}/sys/con_passive.cpp"
			)
	else()
		set(SPEngineSysFiles
			${SPEngineSysFiles}
			"${SharedDir}/sys/sys_unix.cpp"
			"${SharedDir}/sys/con_tty.cpp"
			)
	endif()

	source_group("sys" FILES ${SPEngineSysFiles})
	set(SPEngineFiles ${SPEngineFiles} ${SPEngineSysFiles})

    # Transparently use our bundled minizip.
    list(APPEND SPEngineIncludeDirectories ${MINIZIP_INCLUDE_DIRS})
    list(APPEND SPEngineLibraries          ${MINIZIP_LIBRARIES})

    # Transparently use either bundled or system zlib.
    list(APPEND SPEngineIncludeDirectories ${ZLIB_INCLUDE_DIR})
    list(APPEND SPEngineLibraries          ${ZLIB_LIBRARIES})

	# project macro so we can invoke it twice: for jk2 and for ja
	function(add_sp_project ProjectName Label SPDirName InstallDir Component)
		if(MakeApplicationBundles)
			set_source_files_properties(${SPDirName}/macosx/OpenJK.icns PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
			set(SPEngineFiles ${SPEngineFiles} ${SPDirName}/macosx/OpenJK.icns)
			set_source_files_properties(${SPDirName}/macosx/English.lproj/InfoPlist.strings PROPERTIES MACOSX_PACKAGE_LOCATION Resources/English.lproj)
			set(SPEngineFiles ${SPEngineFiles} ${SPDirName}/macosx/English.lproj/InfoPlist.strings)
		endif(MakeApplicationBundles)

		if(WIN32)
			add_executable(${ProjectName} WIN32 ${SPEngineFiles})
			if(UseInternalSDL2)
				if(CMAKE_SIZEOF_VOID_P EQUAL 4)
					set(SPEngineExtraInstallFiles
						${OpenJKLibDir}/SDL2/bin/x86/SDL2.dll
						)
				else()
					set(SPEngineExtraInstallFiles
						${OpenJKLibDir}/SDL2/bin/x64/SDL2.dll
						)
				endif()
			endif()

=== debian/changelog ===
openjk (0~20240620.c11082b+dfsg-1) experimental; urgency=medium

  * New upstream snapshot

 -- Simon McVittie <smcv@debian.org>  Mon, 22 Jul 2024 10:22:12 +0100

openjk (0~20240501.7b9dfe7+dfsg-1) experimental; urgency=medium

  * New upstream snapshot

 -- Simon McVittie <smcv@debian.org>  Sat, 08 Jun 2024 15:51:11 +0100

openjk (0~20240220.1e8a799+dfsg-1) experimental; urgency=medium

  * New upstream snapshot

 -- Simon McVittie <smcv@debian.org>  Thu, 22 Feb 2024 11:03:41 +0000

openjk (0~20231122.2ed26b3+dfsg-1) experimental; urgency=medium

  * New upstream snapshot
  * Drop a patch that was applied upstream
  * d/copyright: Update
  * d/*.6: Silence warnings from troff by using italic instead of underline
  * apparmor.d: Update from ioquake3
    - Allow reading /usr/share/pipewire
    - Allow SDL audio backends to name their background threads
  * d/openjk-academy-server.install: Don't duplicate systemd service.
    dh_installsystemd installs this for us automatically, and letting
    it take responsibility for the instanced unit makes it possible
    for recent debhelper versions to move the systemd units to
    /usr/lib/systemd automatically.
    Similar to iortcw 1.51.c+dfsg1-6 and openarena 0.8.8+dfsg-7.

 -- Simon McVittie <smcv@debian.org>  Thu, 07 Dec 2023 17:25:08 +0000

openjk (0~20230930.26b8719+dfsg-1) experimental; urgency=medium

  * New upstream snapshot
  * d/copyright: Update
  * d/p/Fix-gsl-lite-compilation-errors.patch:
    Drop patch, superseded by upstream changes

 -- Simon McVittie <smcv@debian.org>  Mon, 02 Oct 2023 11:06:59 +0100

openjk (0~20230917.c1b347d+dfsg-1) experimental; urgency=medium

  * New upstream snapshot

 -- Simon McVittie <smcv@debian.org>  Tue, 19 Sep 2023 16:36:14 +0100

openjk (0~20230520.995d0dd+dfsg-2) experimental; urgency=medium

  * Use the launcher from game-data-packager-runtime instead of a
    shell script.
    This provides a better UX if data files are missing.
    For the dedicated server, we can't guarantee that
    game-data-packager-runtime is installed, and we don't want an explicit
    dependency on it because that would pull in a whole X11 stack, so only
    use it opportunistically, falling back to a shell script implementation
    if necessary.
  * d/p/Fix-gsl-lite-compilation-errors.patch:
    Add patch from upstream PR 1155 to fix compilation with g++-13

 -- Simon McVittie <smcv@debian.org>  Tue, 12 Sep 2023 18:56:30 +0100

openjk (0~20230520.995d0dd+dfsg-1) experimental; urgency=medium

  * New upstream snapshot

 -- Simon McVittie <smcv@debian.org>  Sat, 27 May 2023 17:31:39 +0100

=== debian/control ===
--- 
+++ 
@@ -27,8 +27,8 @@
 Depends:
  ${misc:Depends},
  ${shlibs:Depends},
+ game-data-packager-runtime (>= 75~),
  jedi-academy-data (>= 1.01+41) | game-data-packager,
- jedi-academy-data (>= 1.01+41) | x11-utils | zenity | kdialog,
  openjk-common (= ${binary:Version}),
 Description: Jedi Academy single-player and multiplayer game engine
  Star Wars Jedi Knight: Jedi Academy is a first- and third-person
@@ -74,6 +74,7 @@
 Depends:
  ${misc:Depends},
  ${shlibs:Depends},
+ game-data-packager-runtime (>= 75~),
  jedi-outcast-data (>= 1.04+41) | game-data-packager,
  openjk-common (= ${binary:Version}),
 Description: experimental Jedi Outcast single-player game engine

## openjk 0~20241112.199ddc7+dfsg

=== debian/changelog ===
openjk (0~20241112.199ddc7+dfsg-1) experimental; urgency=medium

  * d/salsa-ci.yml: Use recommended recipe
  * New upstream snapshot

 -- Simon McVittie <smcv@debian.org>  Sat, 18 Jan 2025 14:24:59 +0000
